-----------------------------------------------------------------------------
-- |
-- Module      :  Conjure.FileSystem.Interface
-- Copyright   :  (c) Lemmih 2005
-- License     :  BSD-like
--
-- Maintainer  :  lemmih@gmail.com
-- Stability   :  experimental
-- Portability :  portable
--
-----------------------------------------------------------------------------
module Conjure.FileSystem.Interface
    ( defaultOpen
    , backends
    ) where

import Conjure.Types

import Conjure.FileSystem.InterfaceNaive as Naive
import Conjure.FileSystem.InterfaceMMap as MMap

defaultOpen :: Torrent -> IO Backend
defaultOpen = Naive.open

backends :: [ (String, Torrent -> IO Backend) ]
backends = [ ("Naive", Naive.open)
           , ("MMap",  MMap.open) ]

